---
title: Read All Sessions
description: The GET {{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/sessions operation returns a list of all sessions for the specified user and environment, in descending order based on the session date.
component: pingone-api
page_id: pingone-api:platform:users/user-sessions/read-all-sessions
canonical_url: https://developer.pingidentity.com/pingone-api/platform/users/user-sessions/read-all-sessions.html
section_ids:
  role-information: Role information
  headers: Headers
  example-request: Example Request
  example-response: Example Response
---

# Read All Sessions

##

```none
GET {{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/sessions
```

The `GET {{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/sessions` operation returns a list of all sessions for the specified user and environment, in descending order based on the session date.

The session information returned includes session location, date, browser, operating system, and device information.

A maximum of 10 sessions per user is retained. The expired sessions are returned to the maximum of 10 sessions. The oldest session is dropped when the maximum is reached.

### Role information

A user having the Identity Data Administrator role assigned at the Population level can read sessions for any users in the assigned populations. They cannot read sessions for users outside of those populations, even if the users are in the same environment.

A user having the Identity Data Administrator role assigned at the Environment level can read the sessions of any user in any population in that environment.

### Headers

Authorization      Bearer {{accessToken}}

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/sessions' \
--header 'Authorization: Bearer {{accessToken}}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/sessions")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Get);
request.AddHeader("Authorization", "Bearer {{accessToken}}");
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/sessions"
  method := "GET"

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, nil)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
GET /v1/environments/{{envID}}/users/{{userID}}/sessions HTTP/1.1
Host: {{apiPath}}
Authorization: Bearer {{accessToken}}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("text/plain");
RequestBody body = RequestBody.create(mediaType, "");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/sessions")
  .method("GET", body)
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/sessions",
  "method": "GET",
  "timeout": 0,
  "headers": {
    "Authorization": "Bearer {{accessToken}}"
  },
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'GET',
  'url': '{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/sessions',
  'headers': {
    'Authorization': 'Bearer {{accessToken}}'
  }
};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests

url = "{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/sessions"

payload = {}
headers = {
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("GET", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/sessions');
$request->setMethod(HTTP_Request2::METHOD_GET);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Authorization' => 'Bearer {{accessToken}}'
));
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/sessions")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Get.new(url)
request["Authorization"] = "Bearer {{accessToken}}"

response = http.request(request)
puts response.read_body
```

```swift
var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/sessions")!,timeoutInterval: Double.infinity)
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "GET"

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

200 OK

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/users/710d6278-ccce-4a91-bdb9-ac7a4a0e60d5/sessions"
        }
    },
    "_embedded": {
        "sessions": [
            {
                "_links": {
                    "self": {
                        "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/users/710d6278-ccce-4a91-bdb9-ac7a4a0e60d5/sessions/465b7031-292f-4641-941f-e21240a88a43"
                    },
                    "environment": {
                        "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
                    },
                    "user": {
                        "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/users/710d6278-ccce-4a91-bdb9-ac7a4a0e60d5"
                    }
                },
                "id": "465b7031-292f-4641-941f-e21240a88a43",
                "environment": {
                    "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
                },
                "user": {
                    "id": "710d6278-ccce-4a91-bdb9-ac7a4a0e60d5"
                },
                "createdAt": "2020-07-22T19:26:10.680Z",
                "activeAt": "2020-07-22T19:26:55.666Z",
                "locations": [
                    {
                        "at": "2020-07-22T19:26:55.666Z",
                        "remoteIp": "174.xx.xx.xxx",
                        "city": "tacoma",
                        "state": "washington",
                        "country": "united states"
                    }
                ],
                "lastSignOn": {
                    "remoteIp": "174.xx.xx.xxx",
                    "at": "2020-07-22T19:26:55.665Z"
                },
                "browser": {
                    "name": "Chrome",
                    "version": "83.0.4103"
                },
                "operatingSystem": {
                    "name": "Mac OS X",
                    "version": "10.13.6"
                },
                "device": {
                    "type": "Other"
                }
            },
            {
                "_links": {
                    "self": {
                        "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/users/710d6278-ccce-4a91-bdb9-ac7a4a0e60d5/sessions/9729e107-bb00-4c46-8b49-7c0c1d51761c"
                    },
                    "environment": {
                        "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
                    },
                    "user": {
                        "href": "https://api.pingone.com/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/users/710d6278-ccce-4a91-bdb9-ac7a4a0e60d5"
                    }
                },
                "id": "9729e107-bb00-4c46-8b49-7c0c1d51761c",
                "environment": {
                    "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
                },
                "user": {
                    "id": "710d6278-ccce-4a91-bdb9-ac7a4a0e60d5"
                },
                "createdAt": "2020-07-22T22:21:31.693Z",
                "activeAt": "2020-07-30T18:51:39.384Z",
                "locations": [
                    {
                        "at": "2020-07-22T22:21:42.384Z",
                        "remoteIp": "174.xx.xx.xxx",
                        "city": "tacoma",
                        "state": "washington",
                        "country": "united states"
                    },
                    {
                        "at": "2020-07-22T22:27:35.705Z",
                        "remoteIp": "174.xx.xx.xxx",
                        "city": "tacoma",
                        "state": "washington",
                        "country": "united states"
                    },
                    {
                        "at": "2020-07-30T18:51:01.887Z",
                        "remoteIp": "174.xx.xx.xxx",
                        "city": "tacoma",
                        "state": "washington",
                        "country": "united states"
                    },
                    {
                        "at": "2020-07-30T18:51:39.384Z",
                        "remoteIp": "174.xx.xx.xxx",
                        "city": "tacoma",
                        "state": "washington",
                        "country": "united states"
                    }
                ],
                "lastSignOn": {
                    "remoteIp": "174.xx.xx.xxx",
                    "at": "2020-07-30T18:51:01.887Z"
                },
                "browser": {
                    "name": "Chrome",
                    "version": "83.0.4103"
                },
                "operatingSystem": {
                    "name": "Mac OS X",
                    "version": "10.13.6"
                },
                "device": {
                    "type": "Other"
                }
            }
        ]
    },
    "count": 2,
    "size": 2
}
```
